import Image
from PIL import Image
import matplotlib
import numpy as np
from collections import deque
import glob
import random

#testuje polohu stvorcekov
def test(i,d):
	for k in range(d/2):
		if i%d == k: return True
	return False


def pletivo(d,velkost=600):
	im = Image.new("RGB",(velkost,velkost),(255,255,255)) 	
	for i in range(velkost):
		for j in range(velkost):
			if test(i,d) == True or test(j,d) == True: 
				im.putpixel((i,j),(0,0,0)) #sachovnica
			if i%d==3*d/4 or j%d==3*d/4: im.putpixel((i,j),(255,255,255)) #ciary
			if i%d==3*d/4 and j%d==3*d/4: im.putpixel((i,j),(0,0,0)) #bodky
			#aby to nebola nuda pridal som tam inverzne kruhy
			for r in range(5,400,40):
				if (i-velkost/2)**2 + (j-velkost/2)**2 < (10*r)**2 and \
				(i-velkost/2)**2 + (j-velkost/2)**2 > (r-20)**2:
					(r,g,b) = im.getpixel((i,j))
					im.putpixel((i,j),((abs(r-255),abs(g-255),abs(b-255))))
	im.save("terc_pletivo.png")	

#podfunkcia jedneho kruhu	
def kruh(im,velkost,r,xx,yy,p1):
	for i in range(velkost):
		for j in range(velkost):
			if (i-xx)**2 + (j-yy)**2 < (r)**2 and \
				(i-xx)**2 + (j-yy)**2 > (r-3)**2:
					im.putpixel((i,j),(2*p1,3*p1,3*p1))	
					
#rad kruhov zasebou s postupnou zmenou farby	
def kruhy(r,velkost=600):
	im = Image.new("RGB",(velkost,velkost),(255,255,255)) 	
	for p1 in range(0,100,2):
		xx = velkost/2 + p1
		kruh(im,velkost,r,xx,xx,p1)
	im.save("farebny_valec.png")
	
##podfunkcie do krajiny

def obloha(im,velkost):
	for x in range(velkost):
		for y in range(500):
			im.putpixel((x,y),(y-260,y-340,y-100))

def trava(im,velkost):
	for x in range(velkost):
		for y in range(500,velkost):
			im.putpixel((x,y),(y-420,y-370,y-650))
			
def slnko(im,velkost):
	for i in range(260,340):
		for j in range(velkost):
			if (i-velkost/2)**2 + (j-500)**2 < (40)**2 :
					im.putpixel((i,j),(218,165,32))
	
def hviezda(im,velkost): 
	z = random.randint(1,5) #viac hviezdy vo vyssej casti oblohy
	if z ==1 or z == 2 or z ==3: y = random.randint(7,velkost/3)
	elif z ==4: y = random.randint(velkost/3,2*velkost/5)
	elif z == 5: y = random.randint(2*velkost/5,3*velkost/5)
	x = random.randint(7,velkost-7)
	for i in range(-5,7):
		im.putpixel((x+i,y),(255,255,255))
		im.putpixel((x,y+i),(255,255,255))
		im.putpixel((x+i/2,y+i/2),(255,255,255))
		im.putpixel((x-i/2,y+i/2),(255,255,255))

def krajinka(velkost=600):
	im = Image.new("RGB",(velkost,velkost),(255,255,255))
	obloha(im,velkost)		
	for i in range(100):
		hviezda(im,velkost)
	slnko(im,velkost)
	trava(im,velkost)	
	im.save("krajina.png")
	
#inspirovany navodom, pracujem cez frontu, precitane pixely oznacujem zaciernovanim	
def analyzuj(nazov):
	im = Image.open(nazov)
	im.convert("RGB")
	sirka, vyska = im.size
	objekt=0
	queue = deque()
	for x in range(sirka):
		for y in range(vyska):
			(r,g,b) = im.getpixel((x,y))
			if r !=0 and g!=0 and b!=0:
				objekt +=1
				queue.append([x,y])
				while queue:
					suradnice = queue.popleft()
					queue = kontrola(im,suradnice[0],suradnice[1],queue)			
	print "Pocet objektov:",objekt
	
#funkcia kontrola skuma okolie pixelu, v pripade ze nie je prazdne prida bod do fronty
def kontrola(im,x,y,queue):
	sirka, vyska = im.size
	for k in range(-1,2):
		for l in range(-1,2):
			if (x+k) <0 or (y+l)<0 or (x+k)>(sirka-1) or (y+l) >(vyska-1): pass 
			else: 
				(r,g,b) = im.getpixel((x+k,y+l))
				if r !=0 or g!=0 or b!=0:
					queue.append([x+k,y+l])
					im.putpixel((x+k,y+l),(0,0,0))	
	return queue	

#glob vybera nahodne subory zo zlozky
for files in glob.glob('./HST/deep_space*.png'):
	print files
	analyzuj(files)

kruhy(100)
pletivo(12)
krajinka()

#dik za vyuku, predmet mi dal hodne ;)
#snad uz len prejst cez teoriu na skuske :D
